;Battery test v1.0 by Philip Graf
;12.2.97

#include "TI-85.H"
.org 0
title:  .db "BATTERY TEST V1.0",0

	ROM_CALL(CLEARLCD)
	ld hl,$0200                 ;X=2,Y=0
	ld de,title
	CALL_(writexy)
	ld hl,$0107
	ld de,copystr
	CALL_(writexy)
	ld b,$FF                    ;Bitmap blackline
	ld hl,$FC80                 ;row 8 (FC00h+8*16)
	CALL_(horizline)
	ld hl,$FF60                 ;row 54
	CALL_(horizline)
	ld hl,$0A08                 ;X=9,Y=10
	ld de,infostr
	CALL_(writexymnu)
desk:   ld hl,$1E08
	ld de,batstr
	CALL_(writexymnu)
chkbat:                             ;check battery (in fact contrast :)!)
	ld a,($8007)                ;load contrast value (between 0 and 31)
	ld de,min
	cp $18
	jr nc,cl1
	ld de,bad        
cl1:    cp $0F
	jr nc,cl2
	ld de,mod
cl2:    cp $08
	jr nc,cl3
	ld de,good
cl3:    cp $00 
	jr nc,cl4
	ld de,fant
cl4:    cp $1F
	jr nz,cl5
	ld de,newones
cl5:    ld hl,$1E46
	CALL_(writexymnu)           ;write battery condition
keyloop:                            ;repeat until keypressed
	call GET_KEY
	cp $37                      ;Exit key
	ret z
	cp $04                      ;Up-arrow key
	jr z,up
	cp $01                      ;Down-arrow key
	jr z,down
	jr keyloop
writexy:                            ;write text in normal style
	ld ($800C),hl
	ld hl,(PROGRAM_ADDR)
	add hl,de
	ROM_CALL(D_ZT_STR)
	ret
writexymnu:                         ;write text in menu style
	ld ($8333),hl
	ld hl,(PROGRAM_ADDR)
	add hl,de
	ROM_CALL(D_ZM_STR)
	ret
horizline:
	ld a,16                     ;set 16 bytes (a horizontal line) to 
hlo:    ld (hl),b                   ;bitmap stored in b    
	inc hl
	dec a
	cp 0
	jr nz,hlo
	ret
up:                                 
	ld a,($8007)                 
	cp $1F                      ;1Fh is maximum contrast
	jr z,keyloop
	inc a
upndown:ld ($8007),a
	out (2),a                   ;update contrast
	ld b,$00                    ;Bitmap whiteline   
	ld hl,$FDF0                 ;clear old battery condition
	CALL_(horizline)
	ld hl,$FE00
	CALL_(horizline)
	ld hl,$FE10
	CALL_(horizline)
	ld hl,$FE20
	CALL_(horizline)
	ld hl,$FE30
	CALL_(horizline)
	JUMP_(desk)                 ;write new battery condition
down:
	ld a,($8007)
	cp $00                      ;0 is minimum contrast
	jr z,keyloop
	dec a
	jr upndown

infostr:.db "Use arrowkeys to" 
	.db " change contrast.",0
batstr: .db "Battery condition:",0
min:    .db "Minimum",0
bad:    .db "Bad",0
mod:    .db "Moderate",0
good:   .db "Good",0
fant:   .db "Fantastic",0
newones:.db "Insert new ones",0
copystr:.db "(c) by  Philip Graf",0

.END
